<script setup lang="ts">
  import { ListingFilter, ListingFilterCode, ShopwareSearchParams } from '@shopware-pwa/types';
  import { ProductListingKey } from '~/helpers/injection';

  const { listingType } = inject(ProductListingKey)!;

  const props = defineProps<{
    modelValue?: ShopwareSearchParams;
  }>();

  const emits = defineEmits(['update:modelValue']);

  const { getAvailableFilters } = useListing({
    listingType,
  });

  const mapComponent = (code: ListingFilterCode): string => {
    const components: { [key: string]: string } = {
      properties: 'ListingFiltersProperty',
      manufacturer: 'ListingFiltersProperty',
      price: 'ListingFiltersPrice',
      rating: 'ListingFiltersRating',
      'shipping-free': 'ListingFiltersShippingFree',
    };

    return components[code];
  };

  const updateFilter = (code: string, value: string | boolean | number | number[]) => {
    if (code === 'price') {
      emits('update:modelValue', {
        'min-price': (value as number[])[0],
        'max-price': (value as number[])[1],
      });
    } else {
      emits('update:modelValue', { [code]: value });
    }
  };

  const getValue = (filter: ListingFilter) => {
    if (filter.code === 'price') {
      return [props.modelValue?.['min-price'], props.modelValue?.['max-price']];
    } else {
      return (props.modelValue as any)?.[filter.code];
    }
  };
</script>

<template>
  <div class="flex flex-col flex-wrap gap-5">
    <template v-for="filter in getAvailableFilters" :key="filter.code">
      <Component
        :is="mapComponent(filter.code)"
        v-if="mapComponent(filter.code)"
        :filter="filter"
        :model-value="getValue(filter)"
        @update:model-value="(value: any) => updateFilter(filter.code, value)"
      />
    </template>
  </div>
</template>
